Subject: RE: Proper distribution of cygwin-dependent software.
From: "William J. Leslie" <[email-masked]>
To: "'Oliver Wienand'" <[email-masked]>, <[email-masked]>
Cc: "'William J. Leslie'" <[email-masked]>
Date: Tue, 22 Nov 2005 08:20:08 -0600

> -----Original Message-----
> From: Oliver Wienand [mailto:[email-masked]] 
> Sent: Tuesday, 22 November 2005 02:03
> To: [email-masked]
> Cc: William J. Leslie
> Subject: Re: Proper distribution of cygwin-dependent software.
> 
> Hello,
> 
> we have similar problems with Singular.
> 
> I have used the following solutions:
> 
> 1. Singular is a Cygwin package, so experienced users can 
> just use the 
> Cygwin setup.
> 
> 2. I have build executeables with "Package for the Web", containing a 
> suitable small distribution of Cygwin with Singular and modified the 
> stored repository and the setup.exe, so that the user must 
> only choose 
> the destination directory.
> 
> 3. A further modified version of setup.exe is shipped with the 
> Singular-CD. It works exactly as the standard Cygwin 
> setup.exe, but do 
> not show the dialogs, where you can choose between local and internet 
> install and where can choose your local package rep. It just 
> takes the 
> one on the CD. On the CD we also provide further Cygwin packages, not 
> needed for Singular, as TeTex, gcc, etc.
> 
> If you want to take a look:
> 
> http://www.singular.uni-kl.de
> 
> The advance of this over just delivering some Dlls is, that the user 
> have a correct and full-functional Cygwin environment, which he can 
> shares with other application using similar installation techniques.

I agree that there's no easy, straightforward way to do this.  Consider that there might be four kinds of people who want to use my software:

1. Those who already have Cygwin installed. The installer should not touch their installation.

2. Those who already have Cygwin installed, but are missing some packages (e.g. libfreetype). The installer should add these missing packages (either from the Web, or bundled with the CDROM).

3. Those who don't have Cygwin installed, but might want to start using it later. We must install a base Cygwin setup, but something functional, so that they can add packages to it later.

4. Those who don't have Cygwin installed, don't know what Cygwin is, and will probably never use it. It might be acceptable to just install the Cygwin DLL's for these folks, but you never know if they might decide to use Cygwin in the future... In which case we are better off installing a base Cygwin setup, like we do for the people in group 3.

> 
> I hope that all this is in the scope of the license.
> 

Ehh... I'm pretty sure that all you need to do is make available your package's source tarball, along with the source tarballs of the cygwin packages used.  For distributing on CD-Rom, you can throw the tarballs into a "src" directory.  For distribute via the Web, the easiest thing to do is have the source tarballs (for your project and cygwin packages) downloadable from your website. But I hope this doesn't turn into a licensing discussion...

Thank You
Will

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/